#include<math.h>
#include<malloc.h>




/****************************************************************************
*
*  Nom: quick_sort
*  But: Effectue un tri de Hoare du tableau t entre les elements situes
*       entre lo et hi.
*  Parametres:  *t: C'est un pointeur sur la premiere case du tableau.
*               lo: Valeur d'index minimale du tableau.
*               hi: Valeur d'index maximale du tableau.
*               
*  Auteur: Christian Beaudoin
*  Date: Lundi 27 janvier 1997
*
****************************************************************************/

void quick_sort(double *t, int lo, int hi)
{
    int i,j;
    double mid;
    double tmp;

    
    i=lo; j=hi;
    mid = t[  (lo + hi) >> 1 ]; /* On choisit le pivot. */

    /* On met les elements inferieurs au pivot a gauche
       et les elements superieurs au pivot a droite. */
    do
    {
        while (t[i] < mid) i++;
        while (mid < t[j]) j--;

        if (i <= j)
        {
            /* On echange deux elements. */
            tmp = t[i];
            t[i++] = t[j];
            t[j--] = tmp;
        }
    } while (i <=j);

    if (lo < j) quick_sort(t, lo, j);   /* On trie la partie gauche. */
    if (i < hi) quick_sort(t, i, hi);   /* On trie la partie droite. */
}



